update.sh 48 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066
  1. #!/usr/bin/env bash
  2. ############## Begin Function Section ##############
  3. check_online_status() {
  4. CHECK_ONLINE_DOMAINS=('https://github.com' 'https://hub.docker.com')
  5. for domain in "${CHECK_ONLINE_DOMAINS[@]}"; do
  6. if timeout 6 curl --head --silent --output /dev/null ${domain}; then
  7. return 0
  8. fi
  9. done
  10. return 1
  11. }
  12. prefetch_images() {
  13. [[ -z ${BRANCH} ]] && { echo -e "\e[33m\nUnknown branch...\e[0m"; exit 1; }
  14. git fetch origin #${BRANCH}
  15. while read image; do
  16. if [[ "${image}" == "robbertkl/ipv6nat" ]]; then
  17. if ! grep -qi "ipv6nat-mailcow" docker-compose.yml || grep -qi "enable_ipv6: false" docker-compose.yml; then
  18. continue
  19. fi
  20. fi
  21. RET_C=0
  22. until docker pull ${image}; do
  23. RET_C=$((RET_C + 1))
  24. echo -e "\e[33m\nError pulling $image, retrying...\e[0m"
  25. [ ${RET_C} -gt 3 ] && { echo -e "\e[31m\nToo many failed retries, exiting\e[0m"; exit 1; }
  26. sleep 1
  27. done
  28. done < <(git show origin/${BRANCH}:docker-compose.yml | grep "image:" | awk '{ gsub("image:","", $3); print $2 }')
  29. }
  30. docker_garbage() {
  31. SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
  32. IMGS_TO_DELETE=()
  33. declare -A IMAGES_INFO
  34. COMPOSE_IMAGES=($(grep -oP "image: \Kmailcow.+" "${SCRIPT_DIR}/docker-compose.yml"))
  35. for existing_image in $(docker images --format "{{.ID}}:{{.Repository}}:{{.Tag}}" | grep 'mailcow/'); do
  36. ID=$(echo $existing_image | cut -d ':' -f 1)
  37. REPOSITORY=$(echo $existing_image | cut -d ':' -f 2)
  38. TAG=$(echo $existing_image | cut -d ':' -f 3)
  39. if [[ " ${COMPOSE_IMAGES[@]} " =~ " ${REPOSITORY}:${TAG} " ]]; then
  40. continue
  41. else
  42. IMGS_TO_DELETE+=("$ID")
  43. IMAGES_INFO["$ID"]="$REPOSITORY:$TAG"
  44. fi
  45. done
  46. if [[ ! -z ${IMGS_TO_DELETE[*]} ]]; then
  47. echo "The following unused mailcow images were found:"
  48. for id in "${IMGS_TO_DELETE[@]}"; do
  49. echo " ${IMAGES_INFO[$id]} ($id)"
  50. done
  51. if [ ! $FORCE ]; then
  52. read -r -p "Do you want to delete them to free up some space? [y/N] " response
  53. if [[ "$response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  54. docker rmi ${IMGS_TO_DELETE[*]}
  55. else
  56. echo "OK, skipped."
  57. fi
  58. else
  59. echo "Running in forced mode! Force removing old mailcow images..."
  60. docker rmi ${IMGS_TO_DELETE[*]}
  61. fi
  62. echo -e "\e[32mFurther cleanup...\e[0m"
  63. echo "If you want to cleanup further garbage collected by Docker, please make sure all containers are up and running before cleaning your system by executing \"docker system prune\""
  64. fi
  65. }
  66. in_array() {
  67. local e match="$1"
  68. shift
  69. for e; do [[ "$e" == "$match" ]] && return 0; done
  70. return 1
  71. }
  72. migrate_docker_nat() {
  73. NAT_CONFIG='{"ipv6":true,"fixed-cidr-v6":"fd00:dead:beef:c0::/80","experimental":true,"ip6tables":true}'
  74. # Min Docker version
  75. DOCKERV_REQ=20.10.2
  76. # Current Docker version
  77. DOCKERV_CUR=$(docker version -f '{{.Server.Version}}')
  78. if grep -qi "ipv6nat-mailcow" docker-compose.yml && grep -qi "enable_ipv6: true" docker-compose.yml; then
  79. echo -e "\e[32mNative IPv6 implementation available.\e[0m"
  80. echo "This will enable experimental features in the Docker daemon and configure Docker to do the IPv6 NATing instead of ipv6nat-mailcow."
  81. echo '!!! This step is recommended !!!'
  82. echo "mailcow will try to roll back the changes if starting Docker fails after modifying the daemon.json configuration file."
  83. read -r -p "Should we try to enable the native IPv6 implementation in Docker now (recommended)? [y/N] " dockernatresponse
  84. if [[ ! "${dockernatresponse}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  85. echo "OK, skipping this step."
  86. return 0
  87. fi
  88. fi
  89. # Sort versions and check if we are running a newer or equal version to req
  90. if [ $(printf "${DOCKERV_REQ}\n${DOCKERV_CUR}" | sort -V | tail -n1) == "${DOCKERV_CUR}" ]; then
  91. # If Dockerd daemon json exists
  92. if [ -s /etc/docker/daemon.json ]; then
  93. IFS=',' read -r -a dockerconfig <<< $(cat /etc/docker/daemon.json | tr -cd '[:alnum:],')
  94. if ! in_array ipv6true "${dockerconfig[@]}" || \
  95. ! in_array experimentaltrue "${dockerconfig[@]}" || \
  96. ! in_array ip6tablestrue "${dockerconfig[@]}" || \
  97. ! grep -qi "fixed-cidr-v6" /etc/docker/daemon.json; then
  98. echo -e "\e[33mWarning:\e[0m You seem to have modified the /etc/docker/daemon.json configuration by yourself and not fully/correctly activated the native IPv6 NAT implementation."
  99. echo "You will need to merge your existing configuration manually or fix/delete the existing daemon.json configuration before trying the update process again."
  100. echo -e "Please merge the following content and restart the Docker daemon:\n"
  101. echo ${NAT_CONFIG}
  102. return 1
  103. fi
  104. else
  105. echo "Working on IPv6 NAT, please wait..."
  106. echo ${NAT_CONFIG} > /etc/docker/daemon.json
  107. ip6tables -F -t nat
  108. [[ -e /etc/alpine-release ]] && rc-service docker restart || systemctl restart docker.service
  109. if [[ $? -ne 0 ]]; then
  110. echo -e "\e[31mError:\e[0m Failed to activate IPv6 NAT! Reverting and exiting."
  111. rm /etc/docker/daemon.json
  112. if [[ -e /etc/alpine-release ]]; then
  113. rc-service docker restart
  114. else
  115. systemctl reset-failed docker.service
  116. systemctl restart docker.service
  117. fi
  118. return 1
  119. fi
  120. fi
  121. # Removing legacy container
  122. sed -i '/ipv6nat-mailcow:$/,/^$/d' docker-compose.yml
  123. if [ -s docker-compose.override.yml ]; then
  124. sed -i '/ipv6nat-mailcow:$/,/^$/d' docker-compose.override.yml
  125. if [[ "$(cat docker-compose.override.yml | sed '/^\s*$/d' | wc -l)" == "2" ]]; then
  126. mv docker-compose.override.yml docker-compose.override.yml_backup
  127. fi
  128. fi
  129. echo -e "\e[32mGreat! \e[0mNative IPv6 NAT is active.\e[0m"
  130. else
  131. echo -e "\e[31mPlease upgrade Docker to version ${DOCKERV_REQ} or above.\e[0m"
  132. return 0
  133. fi
  134. }
  135. remove_obsolete_nginx_ports() {
  136. # Removing obsolete docker-compose.override.yml
  137. for override in docker-compose.override.yml docker-compose.override.yaml; do
  138. if [ -s $override ] ; then
  139. if cat $override | grep nginx-mailcow > /dev/null 2>&1; then
  140. if cat $override | grep -E '(\[::])' > /dev/null 2>&1; then
  141. if cat $override | grep -w 80:80 > /dev/null 2>&1 && cat $override | grep -w 443:443 > /dev/null 2>&1 ; then
  142. echo -e "\e[33mBacking up ${override} to preserve custom changes...\e[0m"
  143. echo -e "\e[33m!!! Manual Merge needed (if other overrides are set) !!!\e[0m"
  144. sleep 3
  145. cp $override ${override}_backup
  146. sed -i '/nginx-mailcow:$/,/^$/d' $override
  147. echo -e "\e[33mRemoved obsolete NGINX IPv6 Bind from original override File.\e[0m"
  148. if [[ "$(cat $override | sed '/^\s*$/d' | wc -l)" == "2" ]]; then
  149. mv $override ${override}_empty
  150. echo -e "\e[31m${override} is empty. Renamed it to ensure mailcow is startable.\e[0m"
  151. fi
  152. fi
  153. fi
  154. fi
  155. fi
  156. done
  157. }
  158. detect_docker_compose_command(){
  159. if ! [[ "${DOCKER_COMPOSE_VERSION}" =~ ^(native|standalone)$ ]]; then
  160. if docker compose > /dev/null 2>&1; then
  161. if docker compose version --short | grep -e "^2." -e "^v2." > /dev/null 2>&1; then
  162. DOCKER_COMPOSE_VERSION=native
  163. COMPOSE_COMMAND="docker compose"
  164. echo -e "\e[33mFound Docker Compose Plugin (native).\e[0m"
  165. echo -e "\e[33mSetting the DOCKER_COMPOSE_VERSION Variable to native\e[0m"
  166. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=native/' $SCRIPT_DIR/mailcow.conf
  167. sleep 2
  168. echo -e "\e[33mNotice: You'll have to update this Compose Version via your Package Manager manually!\e[0m"
  169. else
  170. echo -e "\e[31mCannot find Docker Compose with a Version Higher than 2.X.X.\e[0m"
  171. echo -e "\e[31mPlease update/install it manually regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  172. exit 1
  173. fi
  174. elif docker-compose > /dev/null 2>&1; then
  175. if ! [[ $(alias docker-compose 2> /dev/null) ]] ; then
  176. if docker-compose version --short | grep "^2." > /dev/null 2>&1; then
  177. DOCKER_COMPOSE_VERSION=standalone
  178. COMPOSE_COMMAND="docker-compose"
  179. echo -e "\e[33mFound Docker Compose Standalone.\e[0m"
  180. echo -e "\e[33mSetting the DOCKER_COMPOSE_VERSION Variable to standalone\e[0m"
  181. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=standalone/' $SCRIPT_DIR/mailcow.conf
  182. sleep 2
  183. echo -e "\e[33mNotice: For an automatic update of docker-compose please use the update_compose.sh scripts located at the helper-scripts folder.\e[0m"
  184. else
  185. echo -e "\e[31mCannot find Docker Compose with a Version Higher than 2.X.X.\e[0m"
  186. echo -e "\e[31mPlease update/install regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  187. exit 1
  188. fi
  189. fi
  190. else
  191. echo -e "\e[31mCannot find Docker Compose.\e[0m"
  192. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  193. exit 1
  194. fi
  195. elif [ "${DOCKER_COMPOSE_VERSION}" == "native" ]; then
  196. COMPOSE_COMMAND="docker compose"
  197. # Check if Native Compose works and has not been deleted
  198. if ! $COMPOSE_COMMAND > /dev/null 2>&1; then
  199. # IF it not exists/work anymore try the other command
  200. COMPOSE_COMMAND="docker-compose"
  201. if ! $COMPOSE_COMMAND > /dev/null 2>&1 || ! $COMPOSE_COMMAND --version | grep "^2." > /dev/null 2>&1; then
  202. # IF it cannot find Standalone in > 2.X, then script stops
  203. echo -e "\e[31mCannot find Docker Compose or the Version is lower then 2.X.X.\e[0m"
  204. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  205. exit 1
  206. fi
  207. # If it finds the standalone Plugin it will use this instead and change the mailcow.conf Variable accordingly
  208. echo -e "\e[31mFound different Docker Compose Version then declared in mailcow.conf!\e[0m"
  209. echo -e "\e[31mSetting the DOCKER_COMPOSE_VERSION Variable from native to standalone\e[0m"
  210. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=standalone/' $SCRIPT_DIR/mailcow.conf
  211. sleep 2
  212. fi
  213. elif [ "${DOCKER_COMPOSE_VERSION}" == "standalone" ]; then
  214. COMPOSE_COMMAND="docker-compose"
  215. # Check if Standalone Compose works and has not been deleted
  216. if ! $COMPOSE_COMMAND > /dev/null 2>&1 && ! $COMPOSE_COMMAND --version > /dev/null 2>&1 | grep "^2." > /dev/null 2>&1; then
  217. # IF it not exists/work anymore try the other command
  218. COMPOSE_COMMAND="docker compose"
  219. if ! $COMPOSE_COMMAND > /dev/null 2>&1; then
  220. # IF it cannot find Native in > 2.X, then script stops
  221. echo -e "\e[31mCannot find Docker Compose.\e[0m"
  222. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  223. exit 1
  224. fi
  225. # If it finds the native Plugin it will use this instead and change the mailcow.conf Variable accordingly
  226. echo -e "\e[31mFound different Docker Compose Version then declared in mailcow.conf!\e[0m"
  227. echo -e "\e[31mSetting the DOCKER_COMPOSE_VERSION Variable from standalone to native\e[0m"
  228. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=native/' $SCRIPT_DIR/mailcow.conf
  229. sleep 2
  230. fi
  231. fi
  232. }
  233. detect_bad_asn() {
  234. echo -e "\e[33mDetecting if your IP is listed on Spamhaus Bad ASN List...\e[0m"
  235. response=$(curl --connect-timeout 15 --max-time 30 -s -o /dev/null -w "%{http_code}" "https://asn-check.mailcow.email")
  236. if [ "$response" -eq 503 ]; then
  237. if [ -z "$SPAMHAUS_DQS_KEY" ]; then
  238. echo -e "\e[33mYour server's public IP uses an AS that is blocked by Spamhaus to use their DNS public blocklists for Postfix.\e[0m"
  239. echo -e "\e[33mmailcow did not detected a value for the variable SPAMHAUS_DQS_KEY inside mailcow.conf!\e[0m"
  240. sleep 2
  241. echo ""
  242. echo -e "\e[33mTo use the Spamhaus DNS Blocklists again, you will need to create a FREE account for their Data Query Service (DQS) at: https://www.spamhaus.com/free-trial/sign-up-for-a-free-data-query-service-account\e[0m"
  243. echo -e "\e[33mOnce done, enter your DQS API key in mailcow.conf and mailcow will do the rest for you!\e[0m"
  244. echo ""
  245. sleep 2
  246. else
  247. echo -e "\e[33mYour server's public IP uses an AS that is blocked by Spamhaus to use their DNS public blocklists for Postfix.\e[0m"
  248. echo -e "\e[32mmailcow detected a Value for the variable SPAMHAUS_DQS_KEY inside mailcow.conf. Postfix will use DQS with the given API key...\e[0m"
  249. fi
  250. elif [ "$response" -eq 200 ]; then
  251. echo -e "\e[33mCheck completed! Your IP is \e[32mclean\e[0m"
  252. elif [ "$response" -eq 429 ]; then
  253. echo -e "\e[33mCheck completed! \e[31mYour IP seems to be rate limited on the ASN Check service... please try again later!\e[0m"
  254. else
  255. echo -e "\e[31mCheck failed! \e[0mMaybe a DNS or Network problem?\e[0m"
  256. fi
  257. }
  258. ############## End Function Section ##############
  259. # Check permissions
  260. if [ "$(id -u)" -ne "0" ]; then
  261. echo "You need to be root"
  262. exit 1
  263. fi
  264. SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
  265. # Run pre-update-hook
  266. if [ -f "${SCRIPT_DIR}/pre_update_hook.sh" ]; then
  267. bash "${SCRIPT_DIR}/pre_update_hook.sh"
  268. fi
  269. if [[ "$(uname -r)" =~ ^4\.15\.0-60 ]]; then
  270. echo "DO NOT RUN mailcow ON THIS UBUNTU KERNEL!";
  271. echo "Please update to 5.x or use another distribution."
  272. exit 1
  273. fi
  274. if [[ "$(uname -r)" =~ ^4\.4\. ]]; then
  275. if grep -q Ubuntu <<< $(uname -a); then
  276. echo "DO NOT RUN mailcow ON THIS UBUNTU KERNEL!"
  277. echo "Please update to linux-generic-hwe-16.04 by running \"apt-get install --install-recommends linux-generic-hwe-16.04\""
  278. exit 1
  279. fi
  280. echo "mailcow on a 4.4.x kernel is not supported. It may or may not work, please upgrade your kernel or continue at your own risk."
  281. read -p "Press any key to continue..." < /dev/tty
  282. fi
  283. # Exit on error and pipefail
  284. set -o pipefail
  285. # Setting high dc timeout
  286. export COMPOSE_HTTP_TIMEOUT=600
  287. # Add /opt/bin to PATH
  288. PATH=$PATH:/opt/bin
  289. umask 0022
  290. # Unset COMPOSE_COMMAND and DOCKER_COMPOSE_VERSION Variable to be on the newest state.
  291. unset COMPOSE_COMMAND
  292. unset DOCKER_COMPOSE_VERSION
  293. for bin in curl docker git awk sha1sum grep cut; do
  294. if [[ -z $(command -v ${bin}) ]]; then
  295. echo "Cannot find ${bin}, exiting..."
  296. exit 1;
  297. fi
  298. done
  299. export LC_ALL=C
  300. DATE=$(date +%Y-%m-%d_%H_%M_%S)
  301. BRANCH=$(cd ${SCRIPT_DIR}; git rev-parse --abbrev-ref HEAD)
  302. while (($#)); do
  303. case "${1}" in
  304. --check|-c)
  305. echo "Checking remote code for updates..."
  306. LATEST_REV=$(git ls-remote --exit-code --refs --quiet https://github.com/mailcow/mailcow-dockerized ${BRANCH} | cut -f1)
  307. if [ $? -ne 0 ]; then
  308. echo "A problem occurred while trying to fetch the latest revision from github."
  309. exit 99
  310. fi
  311. if [[ -z $(git log HEAD --pretty=format:"%H" | grep "${LATEST_REV}") ]]; then
  312. echo -e "Updated code is available.\nThe changes can be found here: https://github.com/mailcow/mailcow-dockerized/commits/master"
  313. git log --date=short --pretty=format:"%ad - %s" $(git rev-parse --short HEAD)..origin/master
  314. exit 0
  315. else
  316. echo "No updates available."
  317. exit 3
  318. fi
  319. ;;
  320. --ours)
  321. MERGE_STRATEGY=ours
  322. ;;
  323. --skip-start)
  324. SKIP_START=y
  325. ;;
  326. --skip-ping-check)
  327. SKIP_PING_CHECK=y
  328. ;;
  329. --stable)
  330. CURRENT_BRANCH="$(cd ${SCRIPT_DIR}; git rev-parse --abbrev-ref HEAD)"
  331. NEW_BRANCH="master"
  332. ;;
  333. --gc)
  334. echo -e "\e[32mCollecting garbage...\e[0m"
  335. docker_garbage
  336. exit 0
  337. ;;
  338. --nightly)
  339. CURRENT_BRANCH="$(cd ${SCRIPT_DIR}; git rev-parse --abbrev-ref HEAD)"
  340. NEW_BRANCH="nightly"
  341. ;;
  342. --prefetch)
  343. echo -e "\e[32mPrefetching images...\e[0m"
  344. prefetch_images
  345. exit 0
  346. ;;
  347. -f|--force)
  348. echo -e "\e[32mRunning in forced mode...\e[0m"
  349. FORCE=y
  350. ;;
  351. -d|--dev)
  352. echo -e "\e[32mRunning in Developer mode...\e[0m"
  353. DEV=y
  354. ;;
  355. --help|-h)
  356. echo './update.sh [-c|--check, --ours, --gc, --nightly, --prefetch, --skip-start, --skip-ping-check, --stable, -f|--force, -d|--dev, -h|--help]
  357. -c|--check - Check for updates and exit (exit codes => 0: update available, 3: no updates)
  358. --ours - Use merge strategy option "ours" to solve conflicts in favor of non-mailcow code (local changes over remote changes), not recommended!
  359. --gc - Run garbage collector to delete old image tags
  360. --nightly - Switch your mailcow updates to the unstable (nightly) branch. FOR TESTING PURPOSES ONLY!!!!
  361. --prefetch - Only prefetch new images and exit (useful to prepare updates)
  362. --skip-start - Do not start mailcow after update
  363. --skip-ping-check - Skip ICMP Check to public DNS resolvers (Use it only if you´ve blocked any ICMP Connections to your mailcow machine)
  364. --stable - Switch your mailcow updates to the stable (master) branch. Default unless you changed it with --nightly.
  365. -f|--force - Force update, do not ask questions
  366. -d|--dev - Enables Developer Mode (No Checkout of update.sh for tests)
  367. '
  368. exit 1
  369. esac
  370. shift
  371. done
  372. chmod 600 mailcow.conf
  373. source mailcow.conf
  374. detect_docker_compose_command
  375. [[ ! -f mailcow.conf ]] && { echo "mailcow.conf is missing! Is mailcow installed?"; exit 1;}
  376. DOTS=${MAILCOW_HOSTNAME//[^.]};
  377. if [ ${#DOTS} -lt 1 ]; then
  378. echo -e "\e[31mMAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) is not a FQDN!\e[0m"
  379. sleep 1
  380. echo "Please change it to a FQDN and redeploy the stack with $COMPOSE_COMMAND up -d"
  381. exit 1
  382. elif [[ "${MAILCOW_HOSTNAME: -1}" == "." ]]; then
  383. echo "MAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) is ending with a dot. This is not a valid FQDN!"
  384. exit 1
  385. elif [ ${#DOTS} -eq 1 ]; then
  386. echo -e "\e[33mMAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) does not contain a Subdomain. This is not fully tested and may cause issues.\e[0m"
  387. echo "Find more information about why this message exists here: https://github.com/mailcow/mailcow-dockerized/issues/1572"
  388. read -r -p "Do you want to proceed anyway? [y/N] " response
  389. if [[ "$response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  390. echo "OK. Procceding."
  391. else
  392. echo "OK. Exiting."
  393. exit 1
  394. fi
  395. fi
  396. if grep --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox grep detected, please install gnu grep, \"apk add --no-cache --upgrade grep\""; exit 1; fi
  397. # This will also cover sort
  398. if cp --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox cp detected, please install coreutils, \"apk add --no-cache --upgrade coreutils\""; exit 1; fi
  399. if sed --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox sed detected, please install gnu sed, \"apk add --no-cache --upgrade sed\""; exit 1; fi
  400. CONFIG_ARRAY=(
  401. "SKIP_LETS_ENCRYPT"
  402. "SKIP_SOGO"
  403. "USE_WATCHDOG"
  404. "WATCHDOG_NOTIFY_EMAIL"
  405. "WATCHDOG_NOTIFY_WEBHOOK"
  406. "WATCHDOG_NOTIFY_WEBHOOK_BODY"
  407. "WATCHDOG_NOTIFY_BAN"
  408. "WATCHDOG_NOTIFY_START"
  409. "WATCHDOG_EXTERNAL_CHECKS"
  410. "WATCHDOG_SUBJECT"
  411. "SKIP_CLAMD"
  412. "SKIP_IP_CHECK"
  413. "ADDITIONAL_SAN"
  414. "DOVEADM_PORT"
  415. "IPV4_NETWORK"
  416. "IPV6_NETWORK"
  417. "LOG_LINES"
  418. "SNAT_TO_SOURCE"
  419. "SNAT6_TO_SOURCE"
  420. "COMPOSE_PROJECT_NAME"
  421. "DOCKER_COMPOSE_VERSION"
  422. "SQL_PORT"
  423. "API_KEY"
  424. "API_KEY_READ_ONLY"
  425. "API_ALLOW_FROM"
  426. "MAILDIR_GC_TIME"
  427. "MAILDIR_SUB"
  428. "ACL_ANYONE"
  429. "SOLR_HEAP"
  430. "SKIP_SOLR"
  431. "ENABLE_SSL_SNI"
  432. "ALLOW_ADMIN_EMAIL_LOGIN"
  433. "SKIP_HTTP_VERIFICATION"
  434. "SOGO_EXPIRE_SESSION"
  435. "REDIS_PORT"
  436. "DOVECOT_MASTER_USER"
  437. "DOVECOT_MASTER_PASS"
  438. "MAILCOW_PASS_SCHEME"
  439. "ADDITIONAL_SERVER_NAMES"
  440. "ACME_CONTACT"
  441. "WATCHDOG_VERBOSE"
  442. "WEBAUTHN_ONLY_TRUSTED_VENDORS"
  443. "SPAMHAUS_DQS_KEY"
  444. )
  445. detect_bad_asn
  446. sed -i --follow-symlinks '$a\' mailcow.conf
  447. for option in ${CONFIG_ARRAY[@]}; do
  448. if [[ ${option} == "ADDITIONAL_SAN" ]]; then
  449. if ! grep -q ${option} mailcow.conf; then
  450. echo "Adding new option \"${option}\" to mailcow.conf"
  451. echo "${option}=" >> mailcow.conf
  452. fi
  453. elif [[ ${option} == "COMPOSE_PROJECT_NAME" ]]; then
  454. if ! grep -q ${option} mailcow.conf; then
  455. echo "Adding new option \"${option}\" to mailcow.conf"
  456. echo "COMPOSE_PROJECT_NAME=mailcowdockerized" >> mailcow.conf
  457. fi
  458. elif [[ ${option} == "DOCKER_COMPOSE_VERSION" ]]; then
  459. if ! grep -q ${option} mailcow.conf; then
  460. echo "Adding new option \"${option}\" to mailcow.conf"
  461. echo "# Used Docker Compose version" >> mailcow.conf
  462. echo "# Switch here between native (compose plugin) and standalone" >> mailcow.conf
  463. echo "# For more informations take a look at the mailcow docs regarding the configuration options." >> mailcow.conf
  464. echo "# Normally this should be untouched but if you decided to use either of those you can switch it manually here." >> mailcow.conf
  465. echo "# Please be aware that at least one of those variants should be installed on your maschine or mailcow will fail." >> mailcow.conf
  466. echo "" >> mailcow.conf
  467. echo "DOCKER_COMPOSE_VERSION=${DOCKER_COMPOSE_VERSION}" >> mailcow.conf
  468. fi
  469. elif [[ ${option} == "DOVEADM_PORT" ]]; then
  470. if ! grep -q ${option} mailcow.conf; then
  471. echo "Adding new option \"${option}\" to mailcow.conf"
  472. echo "DOVEADM_PORT=127.0.0.1:19991" >> mailcow.conf
  473. fi
  474. elif [[ ${option} == "WATCHDOG_NOTIFY_EMAIL" ]]; then
  475. if ! grep -q ${option} mailcow.conf; then
  476. echo "Adding new option \"${option}\" to mailcow.conf"
  477. echo "WATCHDOG_NOTIFY_EMAIL=" >> mailcow.conf
  478. fi
  479. elif [[ ${option} == "LOG_LINES" ]]; then
  480. if ! grep -q ${option} mailcow.conf; then
  481. echo "Adding new option \"${option}\" to mailcow.conf"
  482. echo '# Max log lines per service to keep in Redis logs' >> mailcow.conf
  483. echo "LOG_LINES=9999" >> mailcow.conf
  484. fi
  485. elif [[ ${option} == "IPV4_NETWORK" ]]; then
  486. if ! grep -q ${option} mailcow.conf; then
  487. echo "Adding new option \"${option}\" to mailcow.conf"
  488. echo '# Internal IPv4 /24 subnet, format n.n.n. (expands to n.n.n.0/24)' >> mailcow.conf
  489. echo "IPV4_NETWORK=172.22.1" >> mailcow.conf
  490. fi
  491. elif [[ ${option} == "IPV6_NETWORK" ]]; then
  492. if ! grep -q ${option} mailcow.conf; then
  493. echo "Adding new option \"${option}\" to mailcow.conf"
  494. echo '# Internal IPv6 subnet in fc00::/7' >> mailcow.conf
  495. echo "IPV6_NETWORK=fd4d:6169:6c63:6f77::/64" >> mailcow.conf
  496. fi
  497. elif [[ ${option} == "SQL_PORT" ]]; then
  498. if ! grep -q ${option} mailcow.conf; then
  499. echo "Adding new option \"${option}\" to mailcow.conf"
  500. echo '# Bind SQL to 127.0.0.1 on port 13306' >> mailcow.conf
  501. echo "SQL_PORT=127.0.0.1:13306" >> mailcow.conf
  502. fi
  503. elif [[ ${option} == "API_KEY" ]]; then
  504. if ! grep -q ${option} mailcow.conf; then
  505. echo "Adding new option \"${option}\" to mailcow.conf"
  506. echo '# Create or override API key for web UI' >> mailcow.conf
  507. echo "#API_KEY=" >> mailcow.conf
  508. fi
  509. elif [[ ${option} == "API_KEY_READ_ONLY" ]]; then
  510. if ! grep -q ${option} mailcow.conf; then
  511. echo "Adding new option \"${option}\" to mailcow.conf"
  512. echo '# Create or override read-only API key for web UI' >> mailcow.conf
  513. echo "#API_KEY_READ_ONLY=" >> mailcow.conf
  514. fi
  515. elif [[ ${option} == "API_ALLOW_FROM" ]]; then
  516. if ! grep -q ${option} mailcow.conf; then
  517. echo "Adding new option \"${option}\" to mailcow.conf"
  518. echo '# Must be set for API_KEY to be active' >> mailcow.conf
  519. echo '# IPs only, no networks (networks can be set via UI)' >> mailcow.conf
  520. echo "#API_ALLOW_FROM=" >> mailcow.conf
  521. fi
  522. elif [[ ${option} == "SNAT_TO_SOURCE" ]]; then
  523. if ! grep -q ${option} mailcow.conf; then
  524. echo "Adding new option \"${option}\" to mailcow.conf"
  525. echo '# Use this IPv4 for outgoing connections (SNAT)' >> mailcow.conf
  526. echo "#SNAT_TO_SOURCE=" >> mailcow.conf
  527. fi
  528. elif [[ ${option} == "SNAT6_TO_SOURCE" ]]; then
  529. if ! grep -q ${option} mailcow.conf; then
  530. echo "Adding new option \"${option}\" to mailcow.conf"
  531. echo '# Use this IPv6 for outgoing connections (SNAT)' >> mailcow.conf
  532. echo "#SNAT6_TO_SOURCE=" >> mailcow.conf
  533. fi
  534. elif [[ ${option} == "MAILDIR_GC_TIME" ]]; then
  535. if ! grep -q ${option} mailcow.conf; then
  536. echo "Adding new option \"${option}\" to mailcow.conf"
  537. echo '# Garbage collector cleanup' >> mailcow.conf
  538. echo '# Deleted domains and mailboxes are moved to /var/vmail/_garbage/timestamp_sanitizedstring' >> mailcow.conf
  539. echo '# How long should objects remain in the garbage until they are being deleted? (value in minutes)' >> mailcow.conf
  540. echo '# Check interval is hourly' >> mailcow.conf
  541. echo 'MAILDIR_GC_TIME=1440' >> mailcow.conf
  542. fi
  543. elif [[ ${option} == "ACL_ANYONE" ]]; then
  544. if ! grep -q ${option} mailcow.conf; then
  545. echo "Adding new option \"${option}\" to mailcow.conf"
  546. echo '# Set this to "allow" to enable the anyone pseudo user. Disabled by default.' >> mailcow.conf
  547. echo '# When enabled, ACL can be created, that apply to "All authenticated users"' >> mailcow.conf
  548. echo '# This should probably only be activated on mail hosts, that are used exclusivly by one organisation.' >> mailcow.conf
  549. echo '# Otherwise a user might share data with too many other users.' >> mailcow.conf
  550. echo 'ACL_ANYONE=disallow' >> mailcow.conf
  551. fi
  552. elif [[ ${option} == "SOLR_HEAP" ]]; then
  553. if ! grep -q ${option} mailcow.conf; then
  554. echo "Adding new option \"${option}\" to mailcow.conf"
  555. echo '# Solr heap size, there is no recommendation, please see Solr docs.' >> mailcow.conf
  556. echo '# Solr is a prone to run OOM on large systems and should be monitored. Unmonitored Solr setups are not recommended.' >> mailcow.conf
  557. echo '# Solr will refuse to start with total system memory below or equal to 2 GB.' >> mailcow.conf
  558. echo "SOLR_HEAP=1024" >> mailcow.conf
  559. fi
  560. elif [[ ${option} == "SKIP_SOLR" ]]; then
  561. if ! grep -q ${option} mailcow.conf; then
  562. echo "Adding new option \"${option}\" to mailcow.conf"
  563. echo '# Solr is disabled by default after upgrading from non-Solr to Solr-enabled mailcows.' >> mailcow.conf
  564. echo '# Disable Solr or if you do not want to store a readable index of your mails in solr-vol-1.' >> mailcow.conf
  565. echo "SKIP_SOLR=y" >> mailcow.conf
  566. fi
  567. elif [[ ${option} == "ENABLE_SSL_SNI" ]]; then
  568. if ! grep -q ${option} mailcow.conf; then
  569. echo "Adding new option \"${option}\" to mailcow.conf"
  570. echo '# Create seperate certificates for all domains - y/n' >> mailcow.conf
  571. echo '# this will allow adding more than 100 domains, but some email clients will not be able to connect with alternative hostnames' >> mailcow.conf
  572. echo '# see https://wiki.dovecot.org/SSL/SNIClientSupport' >> mailcow.conf
  573. echo "ENABLE_SSL_SNI=n" >> mailcow.conf
  574. fi
  575. elif [[ ${option} == "SKIP_SOGO" ]]; then
  576. if ! grep -q ${option} mailcow.conf; then
  577. echo "Adding new option \"${option}\" to mailcow.conf"
  578. echo '# Skip SOGo: Will disable SOGo integration and therefore webmail, DAV protocols and ActiveSync support (experimental, unsupported, not fully implemented) - y/n' >> mailcow.conf
  579. echo "SKIP_SOGO=n" >> mailcow.conf
  580. fi
  581. elif [[ ${option} == "MAILDIR_SUB" ]]; then
  582. if ! grep -q ${option} mailcow.conf; then
  583. echo "Adding new option \"${option}\" to mailcow.conf"
  584. echo '# MAILDIR_SUB defines a path in a users virtual home to keep the maildir in. Leave empty for updated setups.' >> mailcow.conf
  585. echo "#MAILDIR_SUB=Maildir" >> mailcow.conf
  586. echo "MAILDIR_SUB=" >> mailcow.conf
  587. fi
  588. elif [[ ${option} == "WATCHDOG_NOTIFY_WEBHOOK" ]]; then
  589. if ! grep -q ${option} mailcow.conf; then
  590. echo "Adding new option \"${option}\" to mailcow.conf"
  591. echo '# Send notifications to a webhook URL that receives a POST request with the content type "application/json".' >> mailcow.conf
  592. echo '# You can use this to send notifications to services like Discord, Slack and others.' >> mailcow.conf
  593. echo '#WATCHDOG_NOTIFY_WEBHOOK=https://discord.com/api/webhooks/XXXXXXXXXXXXXXXXXXX/XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' >> mailcow.conf
  594. fi
  595. elif [[ ${option} == "WATCHDOG_NOTIFY_WEBHOOK_BODY" ]]; then
  596. if ! grep -q ${option} mailcow.conf; then
  597. echo "Adding new option \"${option}\" to mailcow.conf"
  598. echo '# JSON body included in the webhook POST request. Needs to be in single quotes.' >> mailcow.conf
  599. echo '# Following variables are available: SUBJECT, BODY' >> mailcow.conf
  600. WEBHOOK_BODY='{"username": "mailcow Watchdog", "content": "**${SUBJECT}**\n${BODY}"}'
  601. echo "#WATCHDOG_NOTIFY_WEBHOOK_BODY='${WEBHOOK_BODY}'" >> mailcow.conf
  602. fi
  603. elif [[ ${option} == "WATCHDOG_NOTIFY_BAN" ]]; then
  604. if ! grep -q ${option} mailcow.conf; then
  605. echo "Adding new option \"${option}\" to mailcow.conf"
  606. echo '# Notify about banned IP. Includes whois lookup.' >> mailcow.conf
  607. echo "WATCHDOG_NOTIFY_BAN=y" >> mailcow.conf
  608. fi
  609. elif [[ ${option} == "WATCHDOG_NOTIFY_START" ]]; then
  610. if ! grep -q ${option} mailcow.conf; then
  611. echo "Adding new option \"${option}\" to mailcow.conf"
  612. echo '# Send a notification when the watchdog is started.' >> mailcow.conf
  613. echo "WATCHDOG_NOTIFY_START=y" >> mailcow.conf
  614. fi
  615. elif [[ ${option} == "WATCHDOG_SUBJECT" ]]; then
  616. if ! grep -q ${option} mailcow.conf; then
  617. echo "Adding new option \"${option}\" to mailcow.conf"
  618. echo '# Subject for watchdog mails. Defaults to "Watchdog ALERT" followed by the error message.' >> mailcow.conf
  619. echo "#WATCHDOG_SUBJECT=" >> mailcow.conf
  620. fi
  621. elif [[ ${option} == "WATCHDOG_EXTERNAL_CHECKS" ]]; then
  622. if ! grep -q ${option} mailcow.conf; then
  623. echo "Adding new option \"${option}\" to mailcow.conf"
  624. echo '# Checks if mailcow is an open relay. Requires a SAL. More checks will follow.' >> mailcow.conf
  625. echo '# No data is collected. Opt-in and anonymous.' >> mailcow.conf
  626. echo '# Will only work with unmodified mailcow setups.' >> mailcow.conf
  627. echo "WATCHDOG_EXTERNAL_CHECKS=n" >> mailcow.conf
  628. fi
  629. elif [[ ${option} == "SOGO_EXPIRE_SESSION" ]]; then
  630. if ! grep -q ${option} mailcow.conf; then
  631. echo "Adding new option \"${option}\" to mailcow.conf"
  632. echo '# SOGo session timeout in minutes' >> mailcow.conf
  633. echo "SOGO_EXPIRE_SESSION=480" >> mailcow.conf
  634. fi
  635. elif [[ ${option} == "REDIS_PORT" ]]; then
  636. if ! grep -q ${option} mailcow.conf; then
  637. echo "Adding new option \"${option}\" to mailcow.conf"
  638. echo "REDIS_PORT=127.0.0.1:7654" >> mailcow.conf
  639. fi
  640. elif [[ ${option} == "DOVECOT_MASTER_USER" ]]; then
  641. if ! grep -q ${option} mailcow.conf; then
  642. echo "Adding new option \"${option}\" to mailcow.conf"
  643. echo '# DOVECOT_MASTER_USER and _PASS must _both_ be provided. No special chars.' >> mailcow.conf
  644. echo '# Empty by default to auto-generate master user and password on start.' >> mailcow.conf
  645. echo '# User expands to DOVECOT_MASTER_USER@mailcow.local' >> mailcow.conf
  646. echo '# LEAVE EMPTY IF UNSURE' >> mailcow.conf
  647. echo "DOVECOT_MASTER_USER=" >> mailcow.conf
  648. fi
  649. elif [[ ${option} == "DOVECOT_MASTER_PASS" ]]; then
  650. if ! grep -q ${option} mailcow.conf; then
  651. echo "Adding new option \"${option}\" to mailcow.conf"
  652. echo '# LEAVE EMPTY IF UNSURE' >> mailcow.conf
  653. echo "DOVECOT_MASTER_PASS=" >> mailcow.conf
  654. fi
  655. elif [[ ${option} == "MAILCOW_PASS_SCHEME" ]]; then
  656. if ! grep -q ${option} mailcow.conf; then
  657. echo "Adding new option \"${option}\" to mailcow.conf"
  658. echo '# Password hash algorithm' >> mailcow.conf
  659. echo '# Only certain password hash algorithm are supported. For a fully list of supported schemes,' >> mailcow.conf
  660. echo '# see https://docs.mailcow.email/models/model-passwd/' >> mailcow.conf
  661. echo "MAILCOW_PASS_SCHEME=BLF-CRYPT" >> mailcow.conf
  662. fi
  663. elif [[ ${option} == "ADDITIONAL_SERVER_NAMES" ]]; then
  664. if ! grep -q ${option} mailcow.conf; then
  665. echo "Adding new option \"${option}\" to mailcow.conf"
  666. echo '# Additional server names for mailcow UI' >> mailcow.conf
  667. echo '#' >> mailcow.conf
  668. echo '# Specify alternative addresses for the mailcow UI to respond to' >> mailcow.conf
  669. echo '# This is useful when you set mail.* as ADDITIONAL_SAN and want to make sure mail.maildomain.com will always point to the mailcow UI.' >> mailcow.conf
  670. echo '# If the server name does not match a known site, Nginx decides by best-guess and may redirect users to the wrong web root.' >> mailcow.conf
  671. echo '# You can understand this as server_name directive in Nginx.' >> mailcow.conf
  672. echo '# Comma separated list without spaces! Example: ADDITIONAL_SERVER_NAMES=a.b.c,d.e.f' >> mailcow.conf
  673. echo 'ADDITIONAL_SERVER_NAMES=' >> mailcow.conf
  674. fi
  675. elif [[ ${option} == "ACME_CONTACT" ]]; then
  676. if ! grep -q ${option} mailcow.conf; then
  677. echo "Adding new option \"${option}\" to mailcow.conf"
  678. echo '# Lets Encrypt registration contact information' >> mailcow.conf
  679. echo '# Optional: Leave empty for none' >> mailcow.conf
  680. echo '# This value is only used on first order!' >> mailcow.conf
  681. echo '# Setting it at a later point will require the following steps:' >> mailcow.conf
  682. echo '# https://docs.mailcow.email/troubleshooting/debug-reset_tls/' >> mailcow.conf
  683. echo 'ACME_CONTACT=' >> mailcow.conf
  684. fi
  685. elif [[ ${option} == "WEBAUTHN_ONLY_TRUSTED_VENDORS" ]]; then
  686. if ! grep -q ${option} mailcow.conf; then
  687. echo "Adding new option \"${option}\" to mailcow.conf"
  688. echo "# WebAuthn device manufacturer verification" >> mailcow.conf
  689. echo '# After setting WEBAUTHN_ONLY_TRUSTED_VENDORS=y only devices from trusted manufacturers are allowed' >> mailcow.conf
  690. echo '# root certificates can be placed for validation under mailcow-dockerized/data/web/inc/lib/WebAuthn/rootCertificates' >> mailcow.conf
  691. echo 'WEBAUTHN_ONLY_TRUSTED_VENDORS=n' >> mailcow.conf
  692. fi
  693. elif [[ ${option} == "SPAMHAUS_DQS_KEY" ]]; then
  694. if ! grep -q ${option} mailcow.conf; then
  695. echo "Adding new option \"${option}\" to mailcow.conf"
  696. echo "# Spamhaus Data Query Service Key" >> mailcow.conf
  697. echo '# Optional: Leave empty for none' >> mailcow.conf
  698. echo '# Enter your key here if you are using a blocked ASN (OVH, AWS, Cloudflare e.g) for the unregistered Spamhaus Blocklist.' >> mailcow.conf
  699. echo '# If empty, it will completely disable Spamhaus blocklists if it detects that you are running on a server using a blocked AS.' >> mailcow.conf
  700. echo '# Otherwise it will work as usual.' >> mailcow.conf
  701. echo 'SPAMHAUS_DQS_KEY=' >> mailcow.conf
  702. fi
  703. elif [[ ${option} == "WATCHDOG_VERBOSE" ]]; then
  704. if ! grep -q ${option} mailcow.conf; then
  705. echo "Adding new option \"${option}\" to mailcow.conf"
  706. echo '# Enable watchdog verbose logging' >> mailcow.conf
  707. echo 'WATCHDOG_VERBOSE=n' >> mailcow.conf
  708. fi
  709. elif ! grep -q ${option} mailcow.conf; then
  710. echo "Adding new option \"${option}\" to mailcow.conf"
  711. echo "${option}=n" >> mailcow.conf
  712. fi
  713. done
  714. if [[( ${SKIP_PING_CHECK} == "y")]]; then
  715. echo -e "\e[32mSkipping Ping Check...\e[0m"
  716. else
  717. echo -en "Checking internet connection... "
  718. if ! check_online_status; then
  719. echo -e "\e[31mfailed\e[0m"
  720. exit 1
  721. else
  722. echo -e "\e[32mOK\e[0m"
  723. fi
  724. fi
  725. if ! [ $NEW_BRANCH ]; then
  726. echo -e "\e[33mDetecting which build your mailcow runs on...\e[0m"
  727. sleep 1
  728. if [ ${BRANCH} == "master" ]; then
  729. echo -e "\e[32mYou are receiving stable updates (master).\e[0m"
  730. echo -e "\e[33mTo change that run the update.sh Script one time with the --nightly parameter to switch to nightly builds.\e[0m"
  731. elif [ ${BRANCH} == "nightly" ]; then
  732. echo -e "\e[31mYou are receiving unstable updates (nightly). These are for testing purposes only!!!\e[0m"
  733. sleep 1
  734. echo -e "\e[33mTo change that run the update.sh Script one time with the --stable parameter to switch to stable builds.\e[0m"
  735. else
  736. echo -e "\e[33mYou are receiving updates from a unsupported branch.\e[0m"
  737. sleep 1
  738. echo -e "\e[33mThe mailcow stack might still work but it is recommended to switch to the master branch (stable builds).\e[0m"
  739. echo -e "\e[33mTo change that run the update.sh Script one time with the --stable parameter to switch to stable builds.\e[0m"
  740. fi
  741. elif [ $FORCE ]; then
  742. echo -e "\e[31mYou are running in forced mode!\e[0m"
  743. echo -e "\e[31mA Branch Switch can only be performed manually (monitored).\e[0m"
  744. echo -e "\e[31mPlease rerun the update.sh Script without the --force/-f parameter.\e[0m"
  745. sleep 1
  746. elif [ $NEW_BRANCH == "master" ] && [ $CURRENT_BRANCH != "master" ]; then
  747. echo -e "\e[33mYou are about to switch your mailcow Updates to the stable (master) branch.\e[0m"
  748. sleep 1
  749. echo -e "\e[33mBefore you do: Please take a backup of all components to ensure that no Data is lost...\e[0m"
  750. sleep 1
  751. echo -e "\e[31mWARNING: Please see on GitHub or ask in the communitys if a switch to master is stable or not.
  752. In some rear cases a Update back to master can destroy your mailcow configuration in case of Database Upgrades etc.
  753. Normally a upgrade back to master should be safe during each full release.
  754. Check GitHub for Database Changes and Update only if there similar to the full release!\e[0m"
  755. read -r -p "Are you sure you that want to continue upgrading to the stable (master) branch? [y/N] " response
  756. if [[ ! "${response}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  757. echo "OK. If you prepared yourself for that please run the update.sh Script with the --stable parameter again to trigger this process here."
  758. exit 0
  759. fi
  760. BRANCH=$NEW_BRANCH
  761. DIFF_DIRECTORY=update_diffs
  762. DIFF_FILE=${DIFF_DIRECTORY}/diff_before_upgrade_to_master_$(date +"%Y-%m-%d-%H-%M-%S")
  763. mv diff_before_upgrade* ${DIFF_DIRECTORY}/ 2> /dev/null
  764. if ! git diff-index --quiet HEAD; then
  765. echo -e "\e[32mSaving diff to ${DIFF_FILE}...\e[0m"
  766. mkdir -p ${DIFF_DIRECTORY}
  767. git diff ${BRANCH} --stat > ${DIFF_FILE}
  768. git diff ${BRANCH} >> ${DIFF_FILE}
  769. fi
  770. echo -e "\e[32mSwitching Branch to ${BRANCH}...\e[0m"
  771. git fetch origin
  772. git checkout -f ${BRANCH}
  773. elif [ $NEW_BRANCH == "nightly" ] && [ $CURRENT_BRANCH != "nightly" ]; then
  774. echo -e "\e[33mYou are about to switch your mailcow Updates to the unstable (nightly) branch.\e[0m"
  775. sleep 1
  776. echo -e "\e[33mBefore you do: Please take a backup of all components to ensure that no Data is lost...\e[0m"
  777. sleep 1
  778. echo -e "\e[31mWARNING: A switch to nightly is possible any time. But a switch back (to master) isn't.\e[0m"
  779. read -r -p "Are you sure you that want to continue upgrading to the unstable (nightly) branch? [y/N] " response
  780. if [[ ! "${response}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  781. echo "OK. If you prepared yourself for that please run the update.sh Script with the --nightly parameter again to trigger this process here."
  782. exit 0
  783. fi
  784. BRANCH=$NEW_BRANCH
  785. DIFF_DIRECTORY=update_diffs
  786. DIFF_FILE=${DIFF_DIRECTORY}/diff_before_upgrade_to_nightly_$(date +"%Y-%m-%d-%H-%M-%S")
  787. mv diff_before_upgrade* ${DIFF_DIRECTORY}/ 2> /dev/null
  788. if ! git diff-index --quiet HEAD; then
  789. echo -e "\e[32mSaving diff to ${DIFF_FILE}...\e[0m"
  790. mkdir -p ${DIFF_DIRECTORY}
  791. git diff ${BRANCH} --stat > ${DIFF_FILE}
  792. git diff ${BRANCH} >> ${DIFF_FILE}
  793. fi
  794. git fetch origin
  795. git checkout -f ${BRANCH}
  796. fi
  797. if [ ! $DEV ]; then
  798. echo -e "\e[32mChecking for newer update script...\e[0m"
  799. SHA1_1=$(sha1sum update.sh)
  800. git fetch origin #${BRANCH}
  801. git checkout origin/${BRANCH} update.sh
  802. SHA1_2=$(sha1sum update.sh)
  803. if [[ ${SHA1_1} != ${SHA1_2} ]]; then
  804. echo "update.sh changed, please run this script again, exiting."
  805. chmod +x update.sh
  806. exit 2
  807. fi
  808. fi
  809. if [ ! $FORCE ]; then
  810. read -r -p "Are you sure you want to update mailcow: dockerized? All containers will be stopped. [y/N] " response
  811. if [[ ! "${response}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  812. echo "OK, exiting."
  813. exit 0
  814. fi
  815. migrate_docker_nat
  816. fi
  817. remove_obsolete_nginx_ports
  818. echo -e "\e[32mValidating docker-compose stack configuration...\e[0m"
  819. sed -i 's/HTTPS_BIND:-:/HTTPS_BIND:-/g' docker-compose.yml
  820. sed -i 's/HTTP_BIND:-:/HTTP_BIND:-/g' docker-compose.yml
  821. if ! $COMPOSE_COMMAND config -q; then
  822. echo -e "\e[31m\nOh no, something went wrong. Please check the error message above.\e[0m"
  823. exit 1
  824. fi
  825. echo -e "\e[32mChecking for conflicting bridges...\e[0m"
  826. MAILCOW_BRIDGE=$($COMPOSE_COMMAND config | grep -i com.docker.network.bridge.name | cut -d':' -f2)
  827. while read NAT_ID; do
  828. iptables -t nat -D POSTROUTING $NAT_ID
  829. done < <(iptables -L -vn -t nat --line-numbers | grep $IPV4_NETWORK | grep -E 'MASQUERADE.*all' | grep -v ${MAILCOW_BRIDGE} | cut -d' ' -f1)
  830. DIFF_DIRECTORY=update_diffs
  831. DIFF_FILE=${DIFF_DIRECTORY}/diff_before_update_$(date +"%Y-%m-%d-%H-%M-%S")
  832. mv diff_before_update* ${DIFF_DIRECTORY}/ 2> /dev/null
  833. if ! git diff-index --quiet HEAD; then
  834. echo -e "\e[32mSaving diff to ${DIFF_FILE}...\e[0m"
  835. mkdir -p ${DIFF_DIRECTORY}
  836. git diff --stat > ${DIFF_FILE}
  837. git diff >> ${DIFF_FILE}
  838. fi
  839. echo -e "\e[32mPrefetching images...\e[0m"
  840. prefetch_images
  841. echo -e "\e[32mStopping mailcow...\e[0m"
  842. sleep 2
  843. MAILCOW_CONTAINERS=($($COMPOSE_COMMAND ps -q))
  844. $COMPOSE_COMMAND down
  845. echo -e "\e[32mChecking for remaining containers...\e[0m"
  846. sleep 2
  847. for container in "${MAILCOW_CONTAINERS[@]}"; do
  848. docker rm -f "$container" 2> /dev/null
  849. done
  850. [[ -f data/conf/nginx/ZZZ-ejabberd.conf ]] && rm data/conf/nginx/ZZZ-ejabberd.conf
  851. # Silently fixing remote url from andryyy to mailcow
  852. # git remote set-url origin https://github.com/mailcow/mailcow-dockerized
  853. DEFAULT_REPO=https://github.com/mailcow/mailcow-dockerized
  854. CURRENT_REPO=$(git config --get remote.origin.url)
  855. if [ "$CURRENT_REPO" != "$DEFAULT_REPO" ]; then
  856. echo "The Repository currently used is not the default Mailcow Repository."
  857. echo "Currently Repository: $CURRENT_REPO"
  858. echo "Default Repository: $DEFAULT_REPO"
  859. if [ ! $FORCE ]; then
  860. read -r -p "Should it be changed back to default? [y/N] " repo_response
  861. if [[ "$repo_response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  862. git remote set-url origin $DEFAULT_REPO
  863. fi
  864. else
  865. echo "Running in forced mode... setting Repo to default!"
  866. git remote set-url origin $DEFAULT_REPO
  867. fi
  868. fi
  869. if [ ! $DEV ]; then
  870. echo -e "\e[32mCommitting current status...\e[0m"
  871. [[ -z "$(git config user.name)" ]] && git config user.name moo
  872. [[ -z "$(git config user.email)" ]] && git config user.email moo@cow.moo
  873. [[ ! -z $(git ls-files data/conf/rspamd/override.d/worker-controller-password.inc) ]] && git rm data/conf/rspamd/override.d/worker-controller-password.inc
  874. git add -u
  875. git commit -am "Before update on ${DATE}" > /dev/null
  876. echo -e "\e[32mFetching updated code from remote...\e[0m"
  877. git fetch origin #${BRANCH}
  878. echo -e "\e[32mMerging local with remote code (recursive, strategy: \"${MERGE_STRATEGY:-theirs}\", options: \"patience\"...\e[0m"
  879. git config merge.defaultToUpstream true
  880. git merge -X${MERGE_STRATEGY:-theirs} -Xpatience -m "After update on ${DATE}"
  881. # Need to use a variable to not pass return codes of if checks
  882. MERGE_RETURN=$?
  883. if [[ ${MERGE_RETURN} == 128 ]]; then
  884. echo -e "\e[31m\nOh no, what happened?\n=> You most likely added files to your local mailcow instance that were now added to the official mailcow repository. Please move them to another location before updating mailcow.\e[0m"
  885. exit 1
  886. elif [[ ${MERGE_RETURN} == 1 ]]; then
  887. echo -e "\e[93mPotenial conflict, trying to fix...\e[0m"
  888. git status --porcelain | grep -E "UD|DU" | awk '{print $2}' | xargs rm -v
  889. git add -A
  890. git commit -m "After update on ${DATE}" > /dev/null
  891. git checkout .
  892. echo -e "\e[32mRemoved and recreated files if necessary.\e[0m"
  893. elif [[ ${MERGE_RETURN} != 0 ]]; then
  894. echo -e "\e[31m\nOh no, something went wrong. Please check the error message above.\e[0m"
  895. echo
  896. echo "Run $COMPOSE_COMMAND up -d to restart your stack without updates or try again after fixing the mentioned errors."
  897. exit 1
  898. fi
  899. elif [ $DEV ]; then
  900. echo -e "\e[33mDEVELOPER MODE: Not creating a git diff and commiting it to prevent development stuff within a backup diff...\e[0m"
  901. fi
  902. echo -e "\e[32mFetching new images, if any...\e[0m"
  903. sleep 2
  904. $COMPOSE_COMMAND pull
  905. # Fix missing SSL, does not overwrite existing files
  906. [[ ! -d data/assets/ssl ]] && mkdir -p data/assets/ssl
  907. cp -n -d data/assets/ssl-example/*.pem data/assets/ssl/
  908. echo -e "Checking IPv6 settings... "
  909. if grep -q 'SYSCTL_IPV6_DISABLED=1' mailcow.conf; then
  910. echo
  911. echo '!! IMPORTANT !!'
  912. echo
  913. echo 'SYSCTL_IPV6_DISABLED was removed due to complications. IPv6 can be disabled by editing "docker-compose.yml" and setting "enable_ipv6: true" to "enable_ipv6: false".'
  914. echo "This setting will only be active after a complete shutdown of mailcow by running $COMPOSE_COMMAND down followed by $COMPOSE_COMMAND up -d."
  915. echo
  916. echo '!! IMPORTANT !!'
  917. echo
  918. read -p "Press any key to continue..." < /dev/tty
  919. fi
  920. # Checking for old project name bug
  921. sed -i --follow-symlinks 's#COMPOSEPROJECT_NAME#COMPOSE_PROJECT_NAME#g' mailcow.conf
  922. # Fix Rspamd maps
  923. if [ -f data/conf/rspamd/custom/global_from_blacklist.map ]; then
  924. mv data/conf/rspamd/custom/global_from_blacklist.map data/conf/rspamd/custom/global_smtp_from_blacklist.map
  925. fi
  926. if [ -f data/conf/rspamd/custom/global_from_whitelist.map ]; then
  927. mv data/conf/rspamd/custom/global_from_whitelist.map data/conf/rspamd/custom/global_smtp_from_whitelist.map
  928. fi
  929. # Fix deprecated metrics.conf
  930. if [ -f "data/conf/rspamd/local.d/metrics.conf" ]; then
  931. if [ ! -z "$(git diff --name-only origin/master data/conf/rspamd/local.d/metrics.conf)" ]; then
  932. echo -e "\e[33mWARNING\e[0m - Please migrate your customizations of data/conf/rspamd/local.d/metrics.conf to actions.conf and groups.conf after this update."
  933. echo "The deprecated configuration file metrics.conf will be moved to metrics.conf_deprecated after updating mailcow."
  934. fi
  935. mv data/conf/rspamd/local.d/metrics.conf data/conf/rspamd/local.d/metrics.conf_deprecated
  936. fi
  937. # Set app_info.inc.php
  938. if [ ${BRANCH} == "master" ]; then
  939. mailcow_git_version=$(git describe --tags `git rev-list --tags --max-count=1`)
  940. elif [ ${BRANCH} == "nightly" ]; then
  941. mailcow_git_version=$(git rev-parse --short $(git rev-parse @{upstream}))
  942. mailcow_last_git_version=""
  943. else
  944. mailcow_git_version=$(git rev-parse --short HEAD)
  945. mailcow_last_git_version=""
  946. fi
  947. mailcow_git_commit=$(git rev-parse origin/${BRANCH})
  948. mailcow_git_commit_date=$(git log -1 --format=%ci @{upstream} )
  949. if [ $? -eq 0 ]; then
  950. echo '<?php' > data/web/inc/app_info.inc.php
  951. echo ' $MAILCOW_GIT_VERSION="'$mailcow_git_version'";' >> data/web/inc/app_info.inc.php
  952. echo ' $MAILCOW_LAST_GIT_VERSION="";' >> data/web/inc/app_info.inc.php
  953. echo ' $MAILCOW_GIT_OWNER="mailcow";' >> data/web/inc/app_info.inc.php
  954. echo ' $MAILCOW_GIT_REPO="mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  955. echo ' $MAILCOW_GIT_URL="https://github.com/mailcow/mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  956. echo ' $MAILCOW_GIT_COMMIT="'$mailcow_git_commit'";' >> data/web/inc/app_info.inc.php
  957. echo ' $MAILCOW_GIT_COMMIT_DATE="'$mailcow_git_commit_date'";' >> data/web/inc/app_info.inc.php
  958. echo ' $MAILCOW_BRANCH="'$BRANCH'";' >> data/web/inc/app_info.inc.php
  959. echo ' $MAILCOW_UPDATEDAT='$(date +%s)';' >> data/web/inc/app_info.inc.php
  960. echo '?>' >> data/web/inc/app_info.inc.php
  961. else
  962. echo '<?php' > data/web/inc/app_info.inc.php
  963. echo ' $MAILCOW_GIT_VERSION="'$mailcow_git_version'";' >> data/web/inc/app_info.inc.php
  964. echo ' $MAILCOW_LAST_GIT_VERSION="";' >> data/web/inc/app_info.inc.php
  965. echo ' $MAILCOW_GIT_OWNER="mailcow";' >> data/web/inc/app_info.inc.php
  966. echo ' $MAILCOW_GIT_REPO="mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  967. echo ' $MAILCOW_GIT_URL="https://github.com/mailcow/mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  968. echo ' $MAILCOW_GIT_COMMIT="";' >> data/web/inc/app_info.inc.php
  969. echo ' $MAILCOW_GIT_COMMIT_DATE="";' >> data/web/inc/app_info.inc.php
  970. echo ' $MAILCOW_BRANCH="'$BRANCH'";' >> data/web/inc/app_info.inc.php
  971. echo ' $MAILCOW_UPDATEDAT='$(date +%s)';' >> data/web/inc/app_info.inc.php
  972. echo '?>' >> data/web/inc/app_info.inc.php
  973. echo -e "\e[33mCannot determine current git repository version...\e[0m"
  974. fi
  975. if [[ ${SKIP_START} == "y" ]]; then
  976. echo -e "\e[33mNot starting mailcow, please run \"$COMPOSE_COMMAND up -d --remove-orphans\" to start mailcow.\e[0m"
  977. else
  978. echo -e "\e[32mStarting mailcow...\e[0m"
  979. sleep 2
  980. $COMPOSE_COMMAND up -d --remove-orphans
  981. fi
  982. echo -e "\e[32mCollecting garbage...\e[0m"
  983. docker_garbage
  984. # Run post-update-hook
  985. if [ -f "${SCRIPT_DIR}/post_update_hook.sh" ]; then
  986. bash "${SCRIPT_DIR}/post_update_hook.sh"
  987. fi
  988. # echo "In case you encounter any problem, hard-reset to a state before updating mailcow:"
  989. # echo
  990. # git reflog --color=always | grep "Before update on "
  991. # echo
  992. # echo "Use \"git reset --hard hash-on-the-left\" and run $COMPOSE_COMMAND up -d afterwards."